/**************************************************  DMA Functions Header  ***************************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright 2018, Red Rapids, Inc.

**************************************************  DMA Functions Header  ***************************************************/

#ifndef _DMA_FUNCTIONS_H_
#define _DMA_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

// Structure to store the DMA buffer configuration settings.
typedef struct
{
	unsigned long PageCount;
	unsigned long PagesPerMark;
	unsigned long BurstSizeB;
	unsigned long BurstCount;
} s_DMABuffer;

// Structure to store the results returned by a DMA status query to the device.
typedef struct
{
	unsigned CurrentPage;
	unsigned CurrentBurst;
	unsigned Engine[3];
} s_DMAStatus;

// Prototypes for each of the DMA functions.
int DMAAssign(s_Handle *p_HW, unsigned BufferIndex);
int DMAConfigCheck(s_DMABuf DMA, unsigned *ConfigError);
void DMAInit(s_DMABuf *p_DMA);
int DMALoad(char *p_File, s_DMABuf *DMA, unsigned DataItemSize);
int DMARelease(s_DMABuf *DMA, unsigned DevNum);
int DMASave(char *p_File, s_DMABuf *DMA, unsigned NumPages, unsigned DataItemSize);
void GetDMAStatus(s_Handle *p_HW, unsigned ChannelNumber, s_DMAStatus *p_DMAStatus);

#ifdef __cplusplus
}
#endif

#endif
