/**********************************************  Interrupt Service Routine (ISR) **********************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	The following ISR will execute each time the driver detects an interrupt produced by the device.
	Note:  This example assumes that channel interrupts are enabled but fault interrupts are disabled.

	Rev History: 11-28-2018:	Inital release.

**********************************************  Interrupt Service Routine (ISR) **********************************************/

#ifdef WIN32
	#define EXPORTISR __declspec(dllexport) void
#else
	#define EXPORTISR void
#endif

#include <stdlib.h>

#include "RRadapter.h"				// Adpater device driver common to all Red Rapids PCI Express products.
#include "sigfpga.h"				// SigFPGA application.
#include "global_functions.h"		// Functions common to all Signal Stream hardware and channel types.
#include "utility_functions.h"		// Functions specific to this application example.

EXPORTISR RRadapter_ISR(s_Handle *p_Adapter)
{
	// Process all channels for any status changes.
	ProcessChannels(p_Adapter);

	// The global interrupt mask was set to zero by the driver to suppress further interrupts, so it has to be enabled before exiting the ISR.
	InterruptMask(p_Adapter, 1);
}
